#########################################################################
##  EXAMPLE.R
##  Applies Structural Break Tests and P-Value Computations
##  
##  Bruce E. Hansen
##  Department of Economics
##  Social Science Building
##  University of Wisconsin
##  Madison, WI 53706-1393
##  behansen@wisc.edu
##  http://www.ssc.wisc.edu/~bhansen/
##  
#########################################################################

source ("st_ch.R")

for (main in 1:1){
ar <- 6
t <- 595
dat <- as.matrix(read.table("gmpy.dat"))  
d <- as.matrix(dat[3:(t+2)])
d <- log(d)
dy <- as.matrix(d[2:t]-d[1:(t-1)])
y <- dy[(1+ar):(t-1)]
x <- matrix(1,(t-1-ar),1)
for (i in 1:ar) x <- cbind(x,dy[(1+ar-i):(t-1-i)])
out <- st_ch(y,x,.15,.85,1)
k <- out$kest 
supf <- out$sup
expf <- out$exp
avef <- out$ave
cat ("Monthly Personal Income","\n")
cat ("Sample Period ", dat[1], " ", dat[2],"\n")
cat ("AR(6) Model","\n")
cat ("\n")
stat <- rbind(supf[1,],expf[1,],avef[1,])
names <- rbind("SupLM","ExpLM","AveLM")
cat ("Test     ","Stat    ","P-Value ","\n")
for (j in 1:3) cat (names[j]," ",stat[j,1]," ",stat[j,2],"\n")
cat ("\n")
cat ("\n")

ar <- 12
t <- 583
dat <- as.matrix(read.table("fygm3.dat"))  
d <- as.matrix(dat[3:(t+2)])
dy <- as.matrix(d[2:t]-d[1:(t-1)])
y <- dy[(1+ar):(t-1)]
x <- matrix(1,(t-1-ar),1)
for (i in 1:ar) x <- cbind(x,dy[(1+ar-i):(t-1-i)])
out <- st_ch(y,x,.15,.85,1)
k <- out$kest 
supf <- out$sup
expf <- out$exp
avef <- out$ave
cat ("3-Month T-Bill Rate","\n")
cat ("Sample Period ", dat[1], " ", dat[2],"\n")
cat ("AR(12) Model","\n")
cat ("\n")
stat <- rbind(supf[1,],expf[1,],avef[1,])
names <- rbind("SupLM","ExpLM","AveLM")
cat ("Test     ","Stat    ","P-Value ","\n")
for (j in 1:3) cat (names[j]," ",stat[j,1]," ",stat[j,2],"\n")
cat ("\n")
cat ("\n")
}

